using Gtk;
using System;

namespace Dizzy
{


	public class FileTreeView
	{
		
		// La treeview passataci dalla grafica
		Gtk.TreeView tree;
		
		// Le colonne che ci servono
		Gtk.TreeViewColumn filenameColumn;
		Gtk.TreeViewColumn userColumn;
		
		// La listStore per memorizzare i file
		// che troviamo. 
		Gtk.ListStore fileListStore;

		public FileTreeView (Gtk.TreeView tree)
		{
			// Costruisco la ListStore e popolo di colonne
			// la TreeView
			this.tree = tree;
			this.filenameColumn = new Gtk.TreeViewColumn ();
			filenameColumn.Title = "Nome del file";
		
						
			this.userColumn = new Gtk.TreeViewColumn ();
			userColumn.Title = "Utente";
			
			this.tree.AppendColumn (filenameColumn);
			this.tree.AppendColumn (userColumn);
				
			this.fileListStore = new Gtk.ListStore (typeof(string), // Nome del file
				                                    typeof(string), // Utente
			                                        typeof(string));// Path del file.
			
			this.tree.Model = fileListStore;
			CellSetup ();
			
		}
		
		protected void CellSetup()
		{
			// Filename
			Gtk.CellRendererText filenameRenderer = new Gtk.CellRendererText ();
			filenameColumn.PackStart (filenameRenderer, true);
			filenameColumn.AddAttribute (filenameRenderer, "text", 0);
			
			// Utente
			Gtk.CellRendererText userRenderer = new Gtk.CellRendererText ();
			userColumn.PackStart (userRenderer, true);
			userColumn.AddAttribute (userRenderer, "text", 1);
		}
		
		public void AddFile(Dizzy.File file)
		{
			// Aggiungo i valori effettivi nel liststore.
			fileListStore.AppendValues(file.name, 
			                           file.user,
			                           file.path);
		}
		
		public void Clear ()
		{
			fileListStore.Clear ();
		}
		
		public void SearchInProgress ()
		{
			this.AddFile (new File("Ricerca in corso...", "..."));
		}
		
		public File GetFileFromPath (TreePath path)
		{
			TreeIter iter = new TreeIter ();
			fileListStore.GetIter(out iter, path);
			File f = new File((string) fileListStore.GetValue(iter, 2),
			                  (string) fileListStore.GetValue(iter, 1));
			return f;
		}
		
	}
}
